/* * * * * * * * * * * * *  BEGIN LICENSE BLOCK * * * * * * * * * * * * * * * *
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License Version
   * 1.1 (the "License"); you may not use this file except in compliance with
   * the License. You may obtain a copy of the License at
   * http://www.mozilla.org/MPL/
   * 
   * Software distributed under the License is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   * for the specific language governing rights and limitations under the
   * License.
   *
   * The Original Code is Juergen Binder's Browse Images Code
   *
   * The Initial Developer of the Original Code is Juergen Binder.
   * Portions created by Juergen Binder are Copyright (C) 2005
   * Juergen Binder. All Rights Reserved.
   *
   * Contributor(s): Juergen Binder.
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the LGPL or the GPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   * * * * * * * * * * * *  END LICENSE BLOCK * * * * * * * * * * * * * * * * */


var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("browseimages.");

var props = document.getElementById("g-strings");

var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");

var addButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.add");

var removeButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.remove");

function BIOinit() {
    
    if(addButton == null) {
        addButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.add");
    }
    
    if(removeButton == null) {
        removeButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.remove");
    }
    
    if(prefBranch.getBoolPref("centerImages")) {
        document.getElementById("browseimages.options.centerimages").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.centerimages").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("autoBack")) {
        document.getElementById("browseimages.options.autoBack").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.autoBack").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("statusbarMenu")) {
        document.getElementById("browseimages.options.statusbarMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.statusbarMenu").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("toolsMenu")) {
        document.getElementById("browseimages.options.toolsMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.toolsMenu").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("autoScan")) {
        document.getElementById("browseimages.options.autoScan").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.autoScan").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("goMenu")) {
        document.getElementById("browseimages.options.goMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.goMenu").setAttribute("checked","false");
    }
    
    document.getElementById("browseimages.options.historyMenuOptions.index.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("back_history_menu_backToIndex");
    
    document.getElementById("browseimages.options.historyMenuOptions.back.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("back_history_menu_prevImg");
    
    document.getElementById("browseimages.options.historyMenuOptions.forward.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("forward_history_menu_nextImg");
    
    document.getElementById("browseimages.options.historyMenuOptions.count")
                       .value = prefBranch.getIntPref("max_history_menu_items");
    
    /*document.getElementById("browseimages.save.directory.radiogroup")
                        .selectedIndex = prefBranch.getIntPref("saveBehaviour");
    
    document.getElementById("browseimages.save.directory.textbox").value = prefBranch.getCharPref("saveDirectory");*/
    
    
    var txtbx = document.getElementById(
                                "browseimages.options.historyMenuOptions.count")
                                .inputField;
    
    txtbx.setAttribute("style", "text-align:right;");
    
    BIOloadMenuitems(prefBranch.getCharPref("statusbarMenuitems").split(","));
    
    switch(prefBranch.getCharPref("iconset")) {
        
        case "Flip-Flap" :
        document.getElementById("browseimages.options.iconset.Flip-Flap")
                .setAttribute("selected", "true");
        break;
        
        case "classic" :
        document.getElementById("browseimages.options.iconset.classic")
                .setAttribute("selected", "true");
        break;
        
        case "hideIcon" :
        document.getElementById("browseimages.options.iconset.hideIcon")
                .setAttribute("selected", "true");
        break;
    }
    BIOiconPreview();
    /*
    var theList = prefBranch.getCharPref("theList");
    
    var theListArray = theList.split("\t");
    
    var rule;
    var status;
    
    for(var i = 0; i < theListArray.length - 1; i += 2) {
        rule = theListArray[i];
        status = theListArray[i + 1];
        BIOaddToList(rule, status);
    }*/
    
    document.getElementById("browseimages.options.largeNumberOfLinks.textbox")
                    .value = prefBranch.getIntPref("largeNumberOfLinksLimit");
    
    document.getElementById("browseimages.options.largeNumberOfLinks.defaultAction").selectedIndex = prefBranch.getIntPref("largeNumberOfLinksDefaultAction");
}

function BIOremoveAllChildNodes(list) {
    
    while(list.hasChildNodes()) {
        list.removeChild(list.firstChild);
    }
}

function BIOloadMenuitems(order) {
    
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    var masterItem = document.getElementById("browseimages.options.statusbar.menuitems.master.list").childNodes;
    
    BIOremoveAllChildNodes(availableList);
    BIOremoveAllChildNodes(enabledList);
    
    var availableListItems = new Array(masterItem.length);
    
    availableList.appendItem(masterItem[1].label, masterItem[1].value);        
    
    for(var i = 0; i < order.length; i++) {
        
        var number = parseInt(order[i]) + 1;
        
        if(isNaN(number)){
            continue;
        }
        enabledList.appendItem(masterItem[number].label, masterItem[number].value);
        
        availableListItems[number] = true;
        //availableList.
    }
    
    for(var j = 1; j < availableListItems.length; j++) {
        if(!availableListItems[j]) {
            availableList.appendItem(masterItem[j].label, masterItem[j].value);
        }
    }
    
    if(availableList.getRowCount() > 0) {
        availableList.selectedIndex = 0;
        BIOclick(true);
    } else {
        enabledList.selectedIndex = 0;
        BIOclick(false);
    }
    
}

function BIOreset() {
    
    var mi = prefBranch.getCharPref("statusbarMenuitems");
    
    if(prefBranch.prefHasUserValue("statusbarMenuitems"))
        prefBranch.clearUserPref("statusbarMenuitems");
    
    BIOloadMenuitems(prefBranch.getCharPref("statusbarMenuitems"));
    
    prefBranch.setCharPref("statusbarMenuitems", mi);
}

function BIOsave() {
    
    if(document.getElementById("browseimages.options.statusbarMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("statusbarMenu", 1);
    } else {
        prefBranch.setBoolPref("statusbarMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.goMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("goMenu", 1);
    } else {
        prefBranch.setBoolPref("goMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.toolsMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("toolsMenu", 1);
    } else {
        prefBranch.setBoolPref("toolsMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.centerimages").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("centerImages", 1);
    } else {
        prefBranch.setBoolPref("centerImages", 0);
    }
    
    
    if(document.getElementById("browseimages.options.autoBack").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("autoBack", 1);
    } else {
        prefBranch.setBoolPref("autoBack", 0);
    }
    
    if(document.getElementById("browseimages.options.autoScan").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("autoScan", 1);
    } else {
        prefBranch.setBoolPref("autoScan", 0);
    }
    
    prefBranch.setIntPref("back_history_menu_backToIndex", 
                        2 - document.getElementById(
                        "browseimages.options.historyMenuOptions.index.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("back_history_menu_prevImg",
                        2 - document.getElementById(
                        "browseimages.options.historyMenuOptions.back.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("forward_history_menu_nextImg",
                        2 - document.getElementById(
                        "browseimages.options.historyMenuOptions.forward.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("max_history_menu_items", document.getElementById(
                          "browseimages.options.historyMenuOptions.count").value);
    
        
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    var menuitemlist = new String();
    
    for(var i = 0; i < enabledList.getRowCount(); i++) {
        menuitemlist += enabledList.getItemAtIndex(i).value + ",";
    }
    
    prefBranch.setCharPref("statusbarMenuitems", menuitemlist);
    
    var iconradiogroup = document.getElementById("browseimages.options.iconset.radiogroup");
    prefBranch.setCharPref("iconset", iconradiogroup.selectedItem.value); 
    
    document.getElementById("browseimages.options.theList.tree").save();
    
    document.getElementById("browseimages.options.largeNumberOfLinks.tree").save();
    
    prefBranch.setIntPref("largeNumberOfLinksLimit", parseInt(
                                                       document.getElementById(
                     "browseimages.options.largeNumberOfLinks.textbox").value));
    
    prefBranch.setIntPref("largeNumberOfLinksDefaultAction", document.getElementById("browseimages.options.largeNumberOfLinks.defaultAction").selectedIndex);
    /*
    prefBranch.setIntPref("saveBehaviour",
               document.getElementById("browseimages.save.directory.radiogroup")
               .selectedIndex); 
    
    prefBranch.setCharPref("saveDirectory",
          document.getElementById("browseimages.save.directory.textbox").value);
    */
    return true;
}



function BIOclick(bool) {
    
    if(bool) {
        addButton.setAttribute("disabled", "false");
        removeButton.setAttribute("disabled", "true");
    } else {
        addButton.setAttribute("disabled","true");
        removeButton.setAttribute("disabled","false");
    }
}
/*
 * true => add
 * false => remove
 */
function BIOaddMenuItem(bool) {
    
    
    var sourceList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var targetList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    if(!bool) {
        var tempList = sourceList;
        sourceList = targetList;
        targetList = tempList;
    }
    
    var listitem;
    
    for(var i = 0; i < sourceList.getRowCount(); i++) {
        listitem = sourceList.getItemAtIndex(i);
        if(listitem.selected) {
            try{
                var removeIndex = i;
                
                if(listitem.getAttribute("value") != "0" || bool) {
                    if(targetList.selectedIndex > -1) {
                        targetList.insertItemAt(targetList.selectedIndex, listitem.label, listitem.value);
                    } else {
                        targetList.appendItem(listitem.label, listitem.value);
                    }
                    
                    if(listitem.getAttribute("value") != "0") {
                        i--;
                    }
                    
                } else if(!bool) {
                    i--;
                }
                
                if(listitem.getAttribute("value") != "0" || !bool) {
                    listitem = sourceList.removeItemAt(removeIndex);
                }
                /*
                alert(listitem.getAttribute("label")+ "\n" + 
                      listitem.getAttribute("oncommand")+ "\n" + 
                      listitem.getAttribute("value")+ "\n");*/
                
            } catch(ex) {
                alert(ex);
            }
        }
    }
}

/* true => moveup
*  false => movedown
*/
function BIOmove(dir) {
    
    var delta;
    var list;
    var listitem;
    var moveFirstIndex;
    var moveLastIndex;
    var dontForgetToSelect = new Array();
    
    if(addButton.getAttribute("disabled") == "true") {        
        list =  document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    } else {
        list = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    }
    
    if(dir) {
        moveFirstIndex = 1;
        moveLastIndex = list.getRowCount();
        delta = +1;
    } else {
        moveFirstIndex = list.getRowCount() - 2;
        moveLastIndex = -1;
        delta = -1;
    }
    
    for(var i = moveFirstIndex; i != moveLastIndex; i += delta) {
        listitem = list.getItemAtIndex(i)
        
        if(listitem.selected) {
            
            listitem = list.removeItemAt(i);
            
            i -= delta;
            
            if(i == list.getRowCount()) {
                listitem = list.appendItem(listitem.label, listitem.value);
            } else {
                listitem = list.insertItemAt(i, listitem.label, listitem.value);
            }
            
            dontForgetToSelect.push(listitem);
            
        } 
    }
    
    for(var j in dontForgetToSelect) {
        list.addItemToSelection(dontForgetToSelect[j]);
    }
    
}


function BIOselectAll() {
    
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    
    if(addButton.getAttribute("disabled") == "true") {
        try {
            enabledList.selectAll();
        } catch (e) {
            availableList.selectAll();
        }
    } else {
        /* could not be emtpy as separator always remains there */
        availableList.selectAll();
    }
}

/*
function BIOaddToList(rule, status) {
    
    
    
    if(props == null) {
        props = document.getElementById("g-strings");
    }
    
    try {
        status = props.getString(status);
    } catch(e) {}
    
    var treechildren = document.getElementById("browseimages.options.theliststree.children");
    
    if(rule == null) {
       rule = document.getElementById("browseimages.options.liststextbox").value;
    }
    
    if(rule == "") {
        return;
    }
    
    //alert(rule + "\n\n\\/\n\n" + createRegExp(rule));
    
    var ruleCol = document.getElementById("browseimages.options.theliststree.ruleCol");
    var statusCol = document.getElementById("browseimages.options.theliststree.statusCol");
    
    var index = getIndexForRule(rule)
    
    if(index > -1) {
        BIOsetStatusOfSelection(status);
        statusCol.setAttribute("sortDirection", "natural");
        return;
    }
    
    var item = document.createElement("treeitem");
    var row = document.createElement("treerow");
    var ruleCell = document.createElement("treecell");
    var statusCell = document.createElement("treecell");
    
    ruleCell.setAttribute("label", rule);
    statusCell.setAttribute("label", status);
    
    row.appendChild(ruleCell);
    row.appendChild(statusCell);
    item.appendChild(row);
    treechildren.appendChild(item);
    
    ruleCol.setAttribute("sortDirection", "natural");
    statusCol.setAttribute("sortDirection", "natural");
}


function BIOsetStatusOfSelection(status) {
    
    var tree = document.getElementById("browseimages.options.theliststree");
    
    var treechildren = document.getElementById("browseimages.options.theliststree.children");
    
    var nodes = treechildren.childNodes;
    
    for(var i = 0; i < nodes.length; i++) {
        if(tree.view.selection.isSelected(i)) {
            nodes[i].firstChild.lastChild.setAttribute("label", status);
        }
    }
}
        
        
        
function BIOeditSelectedRule() {
    
    var index = document.getElementById("browseimages.options.theliststree").currentIndex
    
    if(index == -1)
        return;
    
    var rule = document.getElementById("browseimages.options.liststextbox").value;
    
    if(getIndexForRule(rule) == -1) { 
       document.getElementById("browseimages.options.theliststree.children")
               .childNodes[index].firstChild.firstChild.setAttribute("label",
                                                                     rule);
    } else {
        
        if(props == null) {
            props = document.getElementById("g-strings");
        }
        
        try {
            alert(props.getString("alreadyInList"));
        } catch (ex) {
            alert(ex);
        }
    }
}


function getIndexForRule(rule) {
   
//    var nodes = document.getElementById("browseimages.options.theliststree.children").childNodes;
    
    for(var i = 0; i < nodes.length; i++) {
        if(nodes[i].firstChild.firstChild.getAttribute("label") == rule) {
             return i;
        }
    }
    return -1;
}


function BIOtreeSelect(tree) {
    var index = document.getElementById("browseimages.options.theliststree")
                        .currentIndex;
    
    if(index > -1) {
        document.getElementById("browseimages.options.liststextbox").value =
        document.getElementById("browseimages.options.theliststree.children")
                .childNodes[index].firstChild.firstChild.getAttribute("label");
    }
}


function BIOremoveItemAtIndex(index) {
    
    var treechildren = document.getElementById("browseimages.options.theliststree.children");
    var childNodes = treechildren.childNodes;
    
    treechildren.removeChild(childNodes[index]);
    
}


function BIOremove(mode) {
    
    var index = document.getElementById("browseimages.options.theliststree").currentIndex;
    
    var treechildren = document.getElementById("browseimages.options.theliststree.children");
    
    var nodes = treechildren.childNodes;
    
    var tree = document.getElementById("browseimages.options.theliststree");
    
    switch (mode) {
        
        case "all" :
        while(treechildren.hasChildNodes()) {
            treechildren.removeChild(treechildren.firstChild);
        }
        break;
        
        case "selected" :
        for(var i = 0; i < nodes.length; i++) {
            if(tree.view.selection.isSelected(i)) {
                BIOremoveItemAtIndex(i);
                i--;
            }
        }
        break;
    }
    
}


function BIOtreeSort(colName) {
    
    var col;
    var dir;
    var rule;
    var status;
    var rulesArray = new Array();
    var splitter;
    var newSortDirection;
    var nodes = document.getElementById(
                       "browseimages.options.theliststree.children").childNodes;
    
    if(colName == "ruleCol") {
        dir = true;
        col = document.getElementById(
                      "browseimages.options.theliststree.ruleCol");
    } else {
        dir = false;
        col = document.getElementById(
                      "browseimages.options.theliststree.statusCol");
    }
    
    
    for(var i = 0; i < nodes.length; i++) {
        rule = nodes[i].firstChild.firstChild.getAttribute("label");
        status = nodes[i].firstChild.lastChild.getAttribute("label");
        
        if(dir) {
            rulesArray.push(rule + "\t" + status);
        } else {
            rulesArray.push(status + "\t" + rule);
        }
    }
    
    switch (col.getAttribute("sortDirection")) {
        
        case "ascending":
        newSortDirection = "descending";
        rulesArray.reverse();
        break;
        
        case "descending":
        newSortDirection = "ascending";
        rulesArray.reverse();
        break;
        
        case "natural":
        default:
        newSortDirection = "descending";
        rulesArray.sort();
        break;
    }
    
    BIOremove("all");
    
    
    for(var j = 0; j < rulesArray.length; j++) {
        
        splitter = rulesArray[j].split("\t"); 
        
        if(dir) {
            BIOaddToList(splitter[0], splitter[1]);
        } else {
            BIOaddToList(splitter[1], splitter[0]);
        }
    }
    
    col.setAttribute("sortDirection", newSortDirection);
}
*/

function BIOtoggleExplanation() {
    
    if(props == null) {
        props = document.getElementById("g-strings");
    }
    
    var box = document.getElementById(
                      "browseimages.options.theliststree.description.box");
    var button = document.getElementById(
                      "browseimages.options.theliststree.description.button");
    
    if(box.getAttribute("hidden") == "true") {
        box.setAttribute("hidden", "false");
        button.setAttribute("label", props.getString("hideExplanation"));
    } else {
        box.setAttribute("hidden", "true");
        button.setAttribute("label", props.getString("showExplanation"));
    }
    
    
}

function BIOiconPreview() {
    
    var iconset = document.getElementById(
                          "browseimages.options.iconset.radiogroup")
                          .selectedItem.value;
    
    switch(iconset) { 
        
        case "Flip-Flap" :
        
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("hidden","false");
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("hidden","false");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("hidden","false");
                
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("src","chrome://browseimages/skin/Flip-Flap.png");
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("maxwidth","36");
        
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("src","chrome://browseimages/skin/Flip-Flap-grey.png");
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("maxwidth","36");
        
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("src","chrome://browseimages/skin/Flip-Flap-sleep.png");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("maxwidth","36");
        break;
        
        case "classic" :
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("hidden","false");
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("hidden","false");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("hidden","false");
        
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("maxwidth","36");
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("src","chrome://browseimages/skin/classic-colored.png");
        
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("maxwidth","36");
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("src","chrome://browseimages/skin/classic-grey.png");
        
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("src","chrome://browseimages/skin/classic-sleep.png");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("width","36");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("minwidth","36");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("maxwidth","36");
        break;
        
        case "hideIcon" :
        document.getElementById(
                "browseimages.options.iconset.preview.imagelinksfound")
                .setAttribute("hidden","true");
        document.getElementById(
                "browseimages.options.iconset.preview.noimagelinksfound")
                .setAttribute("hidden","true");
        document.getElementById(
                "browseimages.options.iconset.preview.deactivated")
                .setAttribute("hidden","true");
        
        break;
    }
}

function BIOnumberCheck() {
    
    var textbox = document.getElementById("browseimages.options.largeNumberOfLinks.textbox");
    
    if(isNaN(parseInt(textbox.value))) {
       textbox.value = "";
    } else {
        textbox.value = parseInt(textbox.value);
    }
}

/*
function BIObrowse() {
    
    var txtbox = document.getElementById("browseimages.save.directory.textbox");
    
    var filepicker = Components.classes["@mozilla.org/filepicker;1"]
                           .createInstance(Components.interfaces.nsIFilePicker);
    
    var localfile = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
    
    try {
        
        var initDir = txtbox.value;
        
        if(initDir.length == "2" && initDir.charAt(1) == ":")
                    initDir += "\\\\";
        
        localfile.initWithPath(initDir);
        
    } catch (exception) {
        /* Don't complaine ;-) */
/*    }
    
    filepicker.displayDirectory = localfile;
    
    if(props == null)
        props = document.getElementById("g-strings");
    
    
    filepicker.init(window, props.getString("filepickerTitle"), filepicker.modeGetFolder);
    
    if(filepicker.show() == filepicker.returnOK) {
        txtbox.value = filepicker.file.path;
    }
}*/
